
#include <ntifs.h>
#include "WriteProtect.h"


//IRP_MJ_CREATEеõļȻǵļȽ
void GetFileObjectInCreate(IN PIRP irp)
{
    PIO_STACK_LOCATION irpSp;
    PUNICODE_STRING name;
    GET_NAME_CONTROL nameControl;

	UNICODE_STRING  objname;
	WCHAR buff[255];
    
	//ʼobjname
    RtlInitEmptyUnicodeString(&objname, buff, (USHORT)sizeof(buff)*2);
	RtlInitUnicodeString(&objname, (PCWSTR)OBJ_FILE_NAME);

    irpSp = IoGetCurrentIrpStackLocation( irp );

    name = SfGetFileName( irpSp->FileObject, 
                          irp->IoStatus.Status, 
                          &nameControl );
    
   if(!RtlCompareUnicodeString(&objname, name, TRUE)
	   )
   {
#ifdef DBG
	   DbgPrint("FILE_OBJECT :%X\n", irpSp->FileObject);
#endif
	   gFileObject = irpSp->FileObject;
   }
 

    SfGetFileNameCleanup( &nameControl );
}



NTSTATUS
SfWrite(
    IN PDEVICE_OBJECT DeviceObject,
    IN PIRP Irp
    )
{
	NTSTATUS status;
    PIO_STACK_LOCATION irpStack;

    PAGED_CODE();




     
    irpStack = IoGetCurrentIrpStackLocation(Irp);


	 if(irpStack->FileObject == gFileObject)
	 {
		 Irp->IoStatus.Status = STATUS_SUCCESS;
		 Irp->IoStatus.Information = 0;
		 IoCompleteRequest(Irp, IO_NO_INCREMENT);

		 return STATUS_SUCCESS;
	 }

     IoSkipCurrentIrpStackLocation( Irp );
     status = IoCallDriver( ((PSFILTER_DEVICE_EXTENSION) DeviceObject->DeviceExtension)->AttachedToDeviceObject, Irp );

     

     return status;
}